#include "main.h"

int *api(int edi, int esi, int ebp, int esp, int ebx, int edx, int ecx, int eax)
{
	struct task *task = taskNow();
	struct console *cons = task->cons;
	struct sheet *sht;
	struct timer *timer;
	struct file *file;
	struct fhandle *fh;
	struct memory *mem;
	struct DLL_STRPICENV *env;
	struct RGB *pbuf, *q;
	struct pict *pict;
	struct clock *clock;
	struct mapi *mouse;
	unsigned char *fbuf, *buf, *sbuf, *p, *s = 0;
	int *reg = &eax + 1, ds = task->ds, info[8], i = 0, j, x;
	if (eax == 0) {
		/* eax = 0 : AvP[VI */
		return &(task->tss.esp0);
	} else if (eax == 1) {
		/* eax = 1 : R\[ꕶ\
		  edx = R[h */
		consPutc(cons, edx & 0xff, 1);
	} else if (eax == 2) {
		/* eax = 2 : R\[\
		  ebx = ւ̃|C^
		  ecx = \JEgi-1ȂNULL܂Łj */
		consPuts(cons, (char *) (ds + ebx), ecx);
	} else if (eax == 3) {
		/* eax = 3 : EBhE쐬
		  ecx = ̃TCY
		  edx = c̃TCY
		  ebx = EBhEobt@
		  esi = EBhE
		  edi = F
		  ߂l:eax = EBhEnh */
		sht = shtAlloc();
		sht->task = task;
		sht->flag |= SHEET_APP;
		shtSet(sht, (unsigned char *) (ds + ebx), ecx, edx, edi);
		winAlloc(sht, (unsigned char *) (ds + esi), 0);
		shtApp(sht);
		winRefresh();
		reg[7] = (int) sht;
	} else if (eax == 4) {
		/* eax = 4 : EBhElp`\
		  ebx = EBhEnhiȂ烊tbVȂj
		  ecx = ̈ʒu
		  edx = c̈ʒu
		  esi = ̃TCY
		  edi = c̃TCY
		  ebp = Fԍ */
		sht = (struct sheet *) (ebx & 0xfffffffe);
		if (ecx < 0) { ecx = 0; }
		if (edx < 0) { edx = 0; }
		if (esi > sht->sx - 1) { esi = sht->sx - 1; }
		if (edi > sht->sy - 1) { edi = sht->sy - 1; }
		graphicBox(sht, ebp, ecx, edx, esi, edi);
		if ((ebx & 1) == 0) {
			shtRefresh(sht, ecx, edx, esi + 1, edi + 1);
		}
	} else if (eax == 5) {
 		/* eax = 5 : EBhE\
		  ebx = EBhEnhiȂ烊tbVȂj
		  ecx = ̈ʒu
		  edx = c̈ʒu
		  esi = ւ̃|C^
		  ebp = Fԍ
		  edi = \JEgi-1ȂNULL܂Łj */
		sht = (struct sheet *) (ebx & 0xfffffffe);
		s = (char *) (ds + esi);
		if (ecx < 0) { ecx = 0; }
		if (edx < 0) { edx = 0; }
		if (ecx > sht->sx - 1) { ecx = sht->sx - 1; }
		if (edx > sht->sy - 1) { edx = sht->sy - 1; }
		if (edi == -1) {
			for (edi = 0; s[edi] != 0; edi++) { }
			graphicPuts(sht, ebp, ecx, edx, s);
		} else {
			graphicPutsl(sht, ebp, ecx, edx, s, edi);
		}
		if ((ebx & 1) == 0) {
			shtRefresh(sht, ecx, edx, ecx + edi * 16, edx + 16);
		}
	} else if (eax == 6) {
		/* eax = 6 : 擾
		  ebx = Ǘ\̂ւ̃|C^
		  ecx = TCY
		  edx = ǗTCY
		  ߂l:eax = AhX
		  ŏ̏ꍇAǗ\̂̏ */
		if (task->mem == 0) {	/* ŏ */
			memInit((struct memory *) (ds + ebx));
			task->mem = (struct memory *) (ds + ebx);
			memFree(task->mem, (int) (ebx + 32768), edx);
		}
		reg[7] = memAlloc(task->mem, ecx);
	} else if (eax == 7) {
		/* eax = 7 : J
		  ecx = TCY
		  edx = AhX */
		if (task->mem == 0) {
			return 0;
		}
		memFree(task->mem, edx, ecx);
	} else if (eax == 8) {
		/* eax = 8 : EBhE_\
		  ebx = EBhEnhiȂ烊tbVȂj
		  ecx = ̈ʒu
		  edx = c̈ʒu
		  esi = Fԍ */
		sht = (struct sheet *) (ebx & 0xfffffffe);
		if (ecx < 0) { ecx = 0; }
		if (edx < 0) { edx = 0; }
		if (ecx > sht->sx - 1) { ecx = sht->sx - 1; }
		if (edx > sht->sy - 1) { edx = sht->sy - 1; }
		sht->buf[edx * sht->sx + ecx] = esi;
		if ((ebx & 1) == 0) {
			shtRefresh(sht, ecx, edx, ecx + 1, edx + 1);
		}
	} else if (eax == 9) {
		/* eax = 9 : EBhEtbV
		  ebx = EBhEnh
		  ecx = ̈ʒu
		  edx = c̈ʒu
		  esi = ̏I[ʒu
		  edi = c̏I[ʒu */
		shtRefresh((struct sheet *) ebx, ecx, edx, esi + 1, edi + 1);
	} else if (eax == 10) {
		/* eax = 10 : EBhE\
		  ebx = EBhEnhiȂ烊tbVȂj
		  ecx = ̈ʒu
		  edx = c̈ʒu
		  esi = ̏I[ʒu
		  edi = c̏I[ʒu
		  ebp = Fԍ */
		sht = (struct sheet *) (ebx & 0xfffffffe);
		if (ecx < 0) { ecx = 0; }
		if (edx < 0) { edx = 0; }
		if (esi > sht->sx - 1) { esi = sht->sx - 1; }
		if (edi > sht->sy - 1) { edi = sht->sy - 1; }
		graphicLine(sht, ebp, ecx, edx, esi, edi);
		if ((ebx & 1) == 0) {
			if (ecx > esi) {
				i = ecx;
				ecx = esi;
				esi = i;
			}
			if (edx > edi) {
				i = edx;
				edx = edi;
				edi = i;
			}
			shtRefresh(sht, ecx, edx, esi + 1, edi + 1);
		}
	} else if (eax == 11) {
		/* eax = 11 : EBhE폜
		  ebx = EBhEnh */
		shtFree((struct sheet *) ebx);
		winRefresh();
	} else if (eax == 12) {
		/* eax = 12 : L[
		  ecx = 0ȂAL[͂ȂȂ0ԂA
		        1ȂAL[͂܂ŃX[v
		  ߂l:eax = L[R[hiASCIIj */
		for (;;) {
			cli();
			if (fifoStat(&task->fifo) == 0) {
				if (ecx != 0) {
					taskSleep(task);
					sti();
				} else {
					sti();
					reg[7] = -1;
					return 0;
				}
			} else {
				i = fifoGet(&task->fifo);
				sti();
				if (i == 2) {
					cons->cc = _FFFFFF;
				} else if (i == 3) {
					cons->cc = -1;
				} else if (i == 4) {
					cli();
					consExitreq1(cons->sht);
					cons->sht = 0;
					sti();
				} else if (i >= 256) {
					reg[7] = i - 256;
					return 0;
				}
			}
		}
	} else if (eax == 13) {
		/* eax = 13 : ^C}擾
		  ߂l:eax = ^C}nh */
		timer = timerAlloc();
		timer->fapp = 1;
		reg[7] = (int) timer;
	} else if (eax == 14) {
		/* eax = 14 : ^C}ݒ
		  ebx = ^C}nh
		  ecx = ԁi0.01bPʁj
		  edx = f[^ */
		timer = (struct timer *) ebx;
		timerInit(timer, &task->fifo);
		timerSet(timer, ecx, edx + 256);
	} else if (eax == 15) {
		/* eax = 15 : ^C}J
		  ebx = ^C}nh */
		timerFree((struct timer *) ebx);
	} else if (eax == 16) {
		/* eax = 16 : BEEPTEh
		  ecx = gimhzj */
		beep(ecx);
	} else if (eax == 17) {
		/* eax = 17 : t@CI[v
		  ebx = t@C
		  ߂l:eax = t@Cnh */
		for (i = 0; i < 8; i++) {
			if (task->fh[i].buf == 0) {
				break;
			}
		}
		reg[7] = 0;
		if (i < 8) {
			file = fileSearch((unsigned char *) (ds + ebx));
			if (file != 0) {
				reg[7] = i + 1;
				fh = &task->fh[i];
				fh->file = file;
				fh->size = file->size;
				fh->pos = 0;
				fh->mode = 0;
				fh->bcaddr = 0;
				fh->baddr = 0;
				bufSet(fh, 0);
			}
		}
	} else if (eax == 18) {
		/* eax = 18 : t@CN[Y
		  ebx = t@Cnh */
		mem = (struct memory *) MEMORY_ADDR;
		if ((unsigned int) (ebx - 1) < 8) {
			fh = task->fh + (ebx - 1);
		} else {
			return 0;
		}
		bufFlush(fh);
		memFree(mem, (int) fh->buf, 512);
		fh->buf = 0;
	} else if (eax == 19) {
		/* eax = 19 : t@CTCY擾
		  ebx = t@Cnh
		@ecx = t@C擾[h
		        0:t@CTCYA1:ǂݍ݈ʒuA2:I[ǂݍ݈ʒu
		  ߂l:eax = t@CTCY */
		if ((unsigned int) (ebx - 1) < 8) {
			fh = task->fh + (ebx - 1);
		} else {
			return 0;
		}
		if (ecx == 0) {
			reg[7] = fh->size;
		} else if (ecx == 1) {
			reg[7] = fh->pos;
		} else if (ecx == 2) {
			reg[7] = fh->pos - fh->size;
		}
	} else if (eax == 20) {
		/* eax = 20 : t@CV[N
		  ebx = t@Cnh
		  ecx = V[NTCY
		  edx = V[N[h
		        0:ŏ 1:݂̈ʒuA2:I[ */
		if ((unsigned int) (ebx - 1) < 8) {
			fh = task->fh + (ebx - 1);
		} else {
			return 0;
		}
		if (edx == 0) {
			fh->pos = ecx;
		} else if (edx == 1) {
			fh->pos += ecx;
		} else if (edx == 2) {
			fh->pos = fh->size + ecx;
		}
		if (fh->pos < 0) {
			fh->pos = 0;
		}
		if (fh->pos > fh->size) {
			fh->pos = fh->size;
		}
		bufSet(fh, fh->pos);
	} else if (eax == 21) {
		/* eax = 21 : t@C[h
		  ebx = t@Cnh
		  ecx = oCgJEg
		  edx = obt@
		  ߂l:eax = ǂݍ񂾃oCgJEg */
		if ((unsigned int) (ebx - 1) < 8) {
			fh = task->fh + (ebx - 1);
		} else {
			return 0;
		}
		for (i = 0; i < ecx; i++) {
			if (fh->pos >= fh->size) {
				break;
			}
			if (fh->pos - fh->baddr > 512) {
				bufSet(fh, fh->pos);
			}
			*((unsigned char *) (ds + edx + i)) = fh->buf[fh->pos - fh->baddr];
			fh->pos++;
		}
		reg[7] = i;
	} else if (eax == 22) {
		/* eax = 22 : R}hC擾
		  ebx = obt@iƁAst@C΂ĕԂBj
		  ecx = oCgJEg
		  ߂l:eax = ǂݍ񂾃oCgJEg */
		if ((ebx & 0x01) != 0) {
			for (i = 0; cons->line[i] > ' '; i++) { }
			for (; cons->line[i] == ' '; i++) { }
		}
		ebx &= ~1;
		for (j = 0; ; j++) {
			*((unsigned char *) (ds + ebx + j)) = cons->line[i + j];
			if (cons->line[j] == 0) {
				break;
			}
			if (j >= ecx) {
				break;
			}
		}
		reg[7] = j;
	} else if (eax == 23) {
		/* eax = 23 : 摜t@C擾
		  ebx = t@Cnh
		  edx = 摜\̂ւ̃|C^ */
		mem = (struct memory *) MEMORY_ADDR;
		env = (struct DLL_STRPICENV *) memAlloc(mem, sizeof(struct DLL_STRPICENV));
		pict = (struct pict *) (ds + edx);
		if ((unsigned int) (ebx - 1) < 8) {
			fh = task->fh + (ebx - 1);
		} else {
			pict->m = 0;
			goto end023_2;
		}
		fbuf = fileRead(task->fat, fh->file->cno, fh->size);
		if (info_BMP(env, info, fh->size, fbuf) == 0) {
			if (info_JPEG(env, info, fh->size, fbuf) == 0) {
				pict->m = 0;
				goto end023;
			}
		}
		pict->m = info[0];
		pict->sx = info[2];
		pict->sy = info[3];
end023:
		memFree(mem, (unsigned int) fbuf, fh->size);
end023_2:
		memFree(mem, (unsigned int) env, sizeof(struct DLL_STRPICENV));
	} else if (eax == 24) {
		/* eax = 24 : 摜\
		  ebx = EBhEnh
		  ecx = x0
		  edx = t@Cnh
		  esi = y0
		  edi = x1
		  ebp = y1 */
		mem = (struct memory *) MEMORY_ADDR;
		sht = (struct sheet *) ebx;
		env = (struct DLL_STRPICENV *) memAlloc(mem, sizeof(struct DLL_STRPICENV));
		pbuf = (struct RGB *) memAlloc(mem, 786432 * sizeof(struct RGB));
		if ((unsigned int) (edx - 1) < 8) {
			fh = task->fh + (edx - 1);
		} else {
			reg[7] = 0;
			goto end024_2;
		}
		fbuf = fileRead(task->fat, fh->file->cno, fh->size);
		if (info_BMP(env, info, fh->size, fbuf) == 0) {
			if (info_JPEG(env, info, fh->size, fbuf) == 0) {
				reg[7] = 0;
				goto end024;
			}
		}
		if (info[0] == 1) {
			i = decode0_BMP(env, fh->size, fbuf, 4, (char *) pbuf, 0);
		} else {
			i = decode0_JPEG(env, fh->size, fbuf, 4, (char *) pbuf, 0);
		}
		if (i != 0) {
			reg[7] = 0;
			goto end024;
		}
		for (i = esi; i < ebp; i++) {
			p = sht->buf + i * sht->sx;
			q = pbuf + (i - esi) * info[2];
			for (j = ecx; j < edi; j++) {
				p[j] = rgb2pal(j, i, q[j - ecx].r, q[j - ecx].g, q[j - ecx].b);
			}
		}
		shtRefresh(sht, ecx, esi, edi, ebp);
		reg[7] = 1;
end024:
		memFree(mem, (unsigned int) fbuf, fh->size);
end024_2:
		memFree(mem, (unsigned int) pbuf, 786432 * sizeof(struct RGB));
		memFree(mem, (unsigned int) env, sizeof(struct DLL_STRPICENV));
	} else if (eax == 25) {
		/* eax = 25 : v
		  ebx = v\̂ւ̃|C^ */
		clock = (struct clock *) (ds + ebx);
		clockGet(clock);
	} else if (eax == 26) {
		/* eax = 26 : }EX
		  ebx = }EX\̂ւ̃|C^ */
		mouse = (struct mapi *) (ds + ebx);
		mouseGet(mouse);
	} else if (eax == 27) {
		/* eax = 27 : t@C̍쐬
		  ebx = t@C
		  ߂l:eax = t@Cnh */
		mem = (struct memory *) MEMORY_ADDR;
		for (i = 0; i < 8; i++) {
			if (task->fh[i].buf == 0) {
				break;
			}
		}
		reg[7] = 0;
		if (i < 8) {
			file = fileCreate(task->fat, (unsigned char *) (ds + ebx));
			if (file != 0) {
				reg[7] = i + 1;
				fh = &task->fh[i];
				fh->file = file;
				fh->size = file->size;
				fh->pos = 0;
				fh->buf = (unsigned char *) memAlloc(mem, 512);
				fh->mode = 0;
				fh->bcaddr = file->cno;
				fh->baddr = 0;
			}
		}
	} else if (eax == 28) {
		/* eax = 28 : t@C̍폜
		  ebx = t@Cnh */
		mem = (struct memory *) MEMORY_ADDR;
		if ((unsigned int) (ebx - 1) < 8) {
			fh = task->fh + (ebx - 1);
		} else {
			return 0;
		}
		fileDelete(task->fat, fh->file);
		memFree(mem, (int) fh->buf, 512);
		fh->buf = 0;
	} else if (eax == 29) {
		/* eax = 29 : t@C̉
		  ebx = t@Cnh
		  edx = t@C
		  ߂l:eax = G[R[hi1Ȃ琳A0ȂG[j */
		if ((unsigned int) (ebx - 1) < 8) {
			fh = task->fh + (ebx - 1);
		} else {
			return 0;
		}
		i = fileRename(fh->file, (unsigned char *) (ds + edx));
		reg[7] = i;
	} else if (eax == 30) {
		/* eax = 30 : t@C̏
		  ebx = t@Cnh
		  ecx = ރTCY
		  edx = obt@AhX
		  ߂l:eax = 񂾃TCY */
		if ((unsigned int) (ebx - 1) < 8) {
			fh = task->fh + (ebx - 1);
		} else {
			return 0;
		}
		for (i = 0; i < ecx; i++) {
			if (fh->pos > fh->size) {
				fh->size = fh->pos;
				fh->file->size = fh->pos;
			}
			if (fh->pos - fh->baddr > 512) {
				bufSet(fh, fh->pos);
			}
			fh->mode = 1;
			fh->buf[fh->pos - fh->baddr] = *((unsigned char *) (ds + edx + i));
			fh->pos++;
		}
		reg[7] = i;
	} else if (eax == 31) {
		/* eax = 31 : _CAO
		  edx =  */
		mem = (struct memory *) MEMORY_ADDR;
		s = (unsigned char *) (ds + edx);
		for (i = 0; s[i] != 0x00; i++) { }
		if (i > 128) {
			return 0;
		}
		x = 16 + 8 * i;
		if (x < 160) {
			x = 160;
		}
		sht = shtAlloc();
		sbuf = (unsigned char *) memAlloc(mem, x * 52);
		shtSet(sht, sbuf, x, 52, -1);
		winAlloc(sht, "_CAO", 0);
		graphicPuts(sht, _000000, 8, 28, s);
		sht->task = task;
		sht->flag |= SHEET_DIALOGUE;
		shtApp(sht);
		winRefresh();
		for (;;) {
			cli();
			if ((sht->flag & SHEET_DIALOGUE) == 0) {
				sti();
				break;
			} else {
				if (fifoStat(&task->fifo) == 0) {
					taskSleep(task);
					sti();
				} else {
					i = fifoGet(&task->fifo);
					sti();
					if (i == 256 + 0x0a) {
						break;
					}
				}
			}
		}
		shtFree(sht);
		memFree(mem, (unsigned int) sbuf, x * 52);
	} else if (eax == 32) {
		/* eax = 32 : t@C̑I
		  ecx = obt@̃TCY
		  edx = obt@̃AhX
		  ߂l:eax = t@Cnhiw肳ꂽt@CJj */
		mem = (struct memory *) MEMORY_ADDR;
		buf = (unsigned char *) (ds + edx);
		x = 42;
		for (i = 0; i < ecx; i++) {
			buf[i] = 0x00;
		}
		sht = shtAlloc();
		sbuf = (unsigned char *) memAlloc(mem, 10472);
		shtSet(sht, sbuf, 187, 56, -1);
		winAlloc(sht, "t@C̑I", 0);
		textbox(sht, _FFFFFF, 42, 31, 104, 16);
		graphicBox(sht, _000000, x, 31, x + 7, 46);
		sht->task = task;
		sht->flag |= SHEET_DIALOGUE;
		shtApp(sht);
		winRefresh();
		reg[7] = 1;
		s[1] = 0;
		for (;;) {
			cli();
			if ((sht->flag & SHEET_DIALOGUE) == 0) {
				sti();
				reg[7] = 0;
				break;
			} else {
				if (fifoStat(&task->fifo) == 0) {
					taskSleep(task);
					sti();
				} else {
					i = fifoGet(&task->fifo);
					sti();
					if (256 <= i && i < 512) {
						i -= 256;
						if (i == 0x08) {
							if (42 < x) {
								graphicBox(sht, _FFFFFF, x, 31, x + 7, 47);
								shtRefresh(sht, x, 31, x + 8, 48);
								buf[x] = 0x00;
								x -= 8;
							}
						} else if (i == 0x0a) {
							break;
						} else {
							if (x < 138) {
								if (((x - 42) / 8) < ecx - 2) {
									buf[(x - 42) / 8] = i;
									s[0] = i;
									graphicBox(sht, _FFFFFF, x, 31, x + 7, 47);
									graphicPuts(sht, _000000, x, 31, s);
									shtRefresh(sht, x, 31, x + 8, 48);
									x += 8;
								}
							}
						}
						graphicBox(sht, _000000, x, 31, x + 7, 47);
						shtRefresh(sht, x, 31, x + 8, 48);
					}
				}
			}
		}
		if (reg[7] != 0) {
			for (i = 0; i < 8; i++) {
				if (task->fh[i].buf == 0) {
					break;
				}
			}
			reg[7] = 0;
			if (i < 8) {
				file = fileSearch(buf);
				if (file != 0) {
					reg[7] = i + 1;
					fh = &task->fh[i];
					fh->file = file;
					fh->size = file->size;
					fh->pos = 0;
					fh->mode = 0;
					fh->bcaddr = 0;
					fh->baddr = 0;
					bufSet(fh, 0);
				}
			}
		}
		shtFree(sht);
		memFree(mem, (unsigned int) sbuf, 10472);
	}
	return 0;
}
